#ifndef _CRITICALPATH_H_
#define _CRITICALPATH_H_


//
// ڴ˴ C ׼ͷļ
//

#include <stdio.h>


//
// ڴ˴ͷļ
//


#include "Stack.h"


//
// ڴ˴ݽṹ
//

#define MAX_VERTEX_NUM 50				// 
typedef long BOOL;
#define TRUE 1
#define FALSE 0

// ߣ
typedef struct EdgeNode {
	int vertex;							// 򡣼ڶе±ꡣ
	int weight;							// ߵȨֵ
	struct EdgeNode* nextedge;			// ָһߣ
	BOOL isCritical;					// ǷΪؼTURE ǣFALSE 	
	const char* name;					// ߣ
}EdgeNode;

// 
typedef struct VexNode {
	const char* name;					// ʹһַΪ㱣ֵҲΪǶ֡
	EdgeNode* firstarc;	        		// ָһߣ
	int Indegree;						// ȡ
}VexNode;

// ͼʹڽӱ洢
typedef struct GraphList {
	VexNode vexlist[MAX_VERTEX_NUM];	// 
	int length;							// 
}GraphList;


//
// ڴ˴
//


void InitGraph(GraphList* pGraphList);
void DeleteGraph(GraphList* pGraphList);
void FindInDegree(GraphList* pGraphList);
int CriticalPath(GraphList* pGraphList);
void OutputResult(GraphList* pGraphList);


//
// ڴ˴ȫֱ
//

extern Stack stack; 
extern Stack TopoSortResult;
extern int Ve[MAX_VERTEX_NUM];
extern int Vl[MAX_VERTEX_NUM];

#endif /* _CRITICALPATH_H_ */
