#include "CriticalPath.h"

Stack stack, TopoSortResult;
int Ve[MAX_VERTEX_NUM];		  // ¼緢ʱ
int Vl[MAX_VERTEX_NUM];		  // ¼ٷʱ

int main(int argc, char* argv[])
{	
	GraphList GraphList;
	
	//
	// ʼͼ
	//
	InitGraph(&GraphList);
	
	//
	//  InitStack ʼջ
	//
	InitStack(&stack);
	InitStack(&TopoSortResult);

	//
	// ؼ·
	//
	CriticalPath(&GraphList);
	
	
	//
	// 
	//
	OutputResult(&GraphList);
	
	
	//
	// ͼ
	//
	DeleteGraph(&GraphList);
	
	return 0;
}

/*
ܣ
	ͼж


	pGraphList -- ͼָ
	
*/
void FindInDegree(GraphList *pGraphList)
{
			
	//
	// TODO: ڴӴ
	//	
				
}

/*
ܣ
	򡣽(±)ѹջ TopoSortResult 
	¼緢ʱ


	pGraphList -- ͼָ
	
ֵ
	ɹ 1
	ʧܷ 0	
*/
int TopologicalSort(GraphList* pGraphList)
{	
	FindInDegree(pGraphList); // ͼж
		
	//
	// TODO: ڴӴ
	//
		
	return 0;	
}

/*
ܣ
	ؼ·


	pGraphList -- ͼָ
		
ֵ
	ؼ·ɹ 1
	ؼ·ʧܷ 0		
*/
int CriticalPath(GraphList* pGraphList)
{
	EdgeNode* pEdgeNode;			  // ߣڵָ
	int i, k;						  // α
	int ee, el;						  // ʱ

	TopologicalSort(pGraphList); 	  // 
	
	//
	// ʼ¼ٷʱ
	//
	for(i = 0; i < pGraphList->length; i++)	
		Vl[i] = Ve[pGraphList->length - 1]; 
	
	//
	// TODO: ڴӴ
	//
	
	return 0;							
}							

/*
ܣ
	ʹøݳʼͼڽӱ


	pGraphList -- ͼָ
*/
typedef struct Arc{
		int Weight;					// Ȩֵ		
		int VexIndex;				// öڽӵĶС
		const char* Name;			// ߣ
}Arc;
typedef struct VertexArrayEntry {
	const char* Name;				// ơNULL ʾн
	Arc ArcArray[MAX_VERTEX_NUM];	// ߽ڵ顣
}VertexArrayEntry;
const VertexArrayEntry VertexArray[] = 
{
	{ "V1", { {4, 2, "a2"}, {6, 1, "a1"}, {5, 3, "a3"} } },
	{ "V2", { {1, 4, "a4"} } 				  		     },
	{ "V3", { {1, 4, "a5"} } 				 		     },
	{ "V4", { {2, 5, "a6"} }                             },
	{ "V5", { {9, 6, "a7"}, {7, 7, "a8"} }               },
	{ "V6", { {4, 7, "a9"} }                             },
	{ "V7", { {2, 8, "a10"}}                             },
	{ "V8", { {4, 8, "a11"}}                             },
	{ "V9", {  }                                         },	
	{ NULL 					                             }	// ־
};

/*
ܣ
	ʼͼ


	pGraphList -- ͼָ
*/
void InitGraph(GraphList* pGraphList)
{
	int i, j;					// α
	EdgeNode** pEdgeNodePtr;	// ָߣڵָָ
	
	//
	// ͼе length
	//
	pGraphList->length = 0;
	
	//
	// ʹøݳʼͼڽӱ
	//
	for(i=0; i<MAX_VERTEX_NUM ;i++)
	{
		if(NULL == VertexArray[i].Name) // ơNULLʾн
			break;
			
		pGraphList->vexlist[i].name = VertexArray[i].Name;
		
		pEdgeNodePtr = &pGraphList->vexlist[i].firstarc; // ʹָָ򶥵ĵһߣʼָλã
		for(j=0; j<MAX_VERTEX_NUM; j++)
		{
			if(NULL == VertexArray[i].ArcArray[j].Name)
			{
				*pEdgeNodePtr = NULL;
				break;
			}
			
			*pEdgeNodePtr = (EdgeNode*)malloc(sizeof(EdgeNode));
			(*pEdgeNodePtr)->vertex = VertexArray[i].ArcArray[j].VexIndex;
			(*pEdgeNodePtr)->weight = VertexArray[i].ArcArray[j].Weight;
			(*pEdgeNodePtr)->name = VertexArray[i].ArcArray[j].Name;
			(*pEdgeNodePtr)->isCritical = FALSE;
			pEdgeNodePtr = &(*pEdgeNodePtr)->nextedge;
		}
		
		pGraphList->length++;
	}
}

/*
ܣ
	ͼ


	pGraphList -- ͼָ
*/
void DeleteGraph(GraphList* pGraphList)
{
	int i;
	EdgeNode* pEdgeNode;
	
	for(i=0; i<pGraphList->length; i++)
	{
		while(pGraphList->vexlist[i].firstarc != NULL)
		{
			pEdgeNode = pGraphList->vexlist[i].firstarc;
			pGraphList->vexlist[i].firstarc = pEdgeNode->nextedge;
			free(pEdgeNode);
		}
	}
	
	pGraphList->length = 0;
}

/*
ܣ
	


	
*/
void OutputResult(GraphList* pGraphList)
{
	EdgeNode* pEdgeNode;	// ߣڵָ
	int i, k;				// ±
	int ee, el;				// ʱ
	
	printf("VertexSeq:\t\t\t\t\t\t\t\t\t");
	for(i = 0; i < pGraphList->length; i++)
	{
		printf("\t%s", pGraphList->vexlist[i].name);
	}
	printf("\n");
	
	printf("An array of the earliest events to occur Ve:");
	for(i = 0; i < pGraphList->length; i++)
	{
		printf("\t%d ", Ve[i]);
	}
	printf("\n");
	
	printf("Event latest occurrentce time array Vl:\t\t");
	for(i = 0; i < pGraphList->length; i++)
	{
		printf("\t%d ", Vl[i]);
	}
	printf("\n");
	
	printf("AdjacencyList:\n");
	printf("Vertex   (VertexSubscript ActivityName Weight)...\n");
	for(i = 0; i < pGraphList->length; i++)
	{
		printf("%s",pGraphList->vexlist[i].name);
		for(pEdgeNode = pGraphList->vexlist[i].firstarc; pEdgeNode!=NULL; pEdgeNode = pEdgeNode->nextedge)
		{
			//
			// ߣڵָָĶ±걣浽 k 
			//

			k = pEdgeNode->vertex;
	
			//
			// ee  Ve[i] ֵle  Vl[k] ֵȥ߽ڵָӦȨֵ
			//

			ee = Ve[i];
			el = Vl[k] - pEdgeNode->weight;

			if(ee == el)
			{
				printf(" -> (%2d [%s=%d])", pEdgeNode->vertex, pEdgeNode->name, pEdgeNode->weight);
				pEdgeNode->isCritical = TRUE; 
			}
			else
			{
				printf(" -> (%2d  %s=%d )", pEdgeNode->vertex, pEdgeNode->name, pEdgeNode->weight);
			}	
		}
		printf(" -> NULL \n");

	}	
}
